var __create = Object.create;
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __markAsModule = (target) => __defProp(target, "__esModule", { value: true });
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
var __export = (target, all) => {
  __markAsModule(target);
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __reExport = (target, module2, desc) => {
  if (module2 && typeof module2 === "object" || typeof module2 === "function") {
    for (let key of __getOwnPropNames(module2))
      if (!__hasOwnProp.call(target, key) && key !== "default")
        __defProp(target, key, { get: () => module2[key], enumerable: !(desc = __getOwnPropDesc(module2, key)) || desc.enumerable });
  }
  return target;
};
var __toModule = (module2) => {
  return __reExport(__markAsModule(__defProp(module2 != null ? __create(__getProtoOf(module2)) : {}, "default", module2 && module2.__esModule && "default" in module2 ? { get: () => module2.default, enumerable: true } : { value: module2, enumerable: true })), module2);
};

// src/index.ts
__export(exports, {
  MappingProxy: () => MappingProxy,
  ObserverArray: () => ObserverArray,
  ProxyContext: () => ProxyContext,
  ProxyProvider: () => ProxyProvider,
  StockContext: () => StockContext,
  StockProxy: () => StockProxy,
  StockRoot: () => StockRoot,
  intercept: () => intercept,
  isInnerPath: () => isInnerPath,
  joinPaths: () => joinPaths,
  longestCommonPath: () => longestCommonPath,
  normalizePath: () => normalizePath,
  relativePath: () => relativePath,
  useAllStockValues: () => useAllStockValues,
  useMappingProxy: () => useMappingProxy,
  useObservers: () => useObservers,
  useStock: () => useStock,
  useStockContext: () => useStockContext,
  useStockState: () => useStockState,
  useStockValue: () => useStockValue
});

// src/hooks/useStock.ts
var import_react4 = __toModule(require("react"));
var import_cloneDeep = __toModule(require("lodash/cloneDeep"));
var import_isFunction = __toModule(require("lodash/isFunction"));
var import_pxth4 = __toModule(require("pxth"));

// src/hooks/useDebugStock.ts
var import_react = __toModule(require("react"));
var import_pxth = __toModule(require("pxth"));
var StockedEvent;
(function(StockedEvent2) {
  StockedEvent2["NEW"] = "new";
  StockedEvent2["BATCH_UPDATE"] = "update";
})(StockedEvent || (StockedEvent = {}));
var stockIndex = -1;
var useDebugStock = /* @__PURE__ */ __name((stock) => {
  (0, import_react.useEffect)(() => {
    if (window.__STOCKED_DEVTOOLS_HOOK) {
      const currentStockId = ++stockIndex;
      window.__STOCKED_DEVTOOLS_HOOK.raiseEvent(StockedEvent.NEW, {
        data: stock.getValues(),
        id: currentStockId
      });
      return stock.watchBatchUpdates((data) => window.__STOCKED_DEVTOOLS_HOOK.raiseEvent(StockedEvent.BATCH_UPDATE, {
        data: __spreadProps(__spreadValues({}, data), {
          origin: (0, import_pxth.getPxthSegments)(data.origin)
        }),
        id: currentStockId
      }));
    }
    return () => {
    };
  }, []);
}, "useDebugStock");

// src/hooks/useObservers.ts
var import_react3 = __toModule(require("react"));
var import_pxth3 = __toModule(require("pxth"));
var import_tiny_invariant3 = __toModule(require("tiny-invariant"));

// src/utils/ObserverArray.ts
var import_tiny_invariant = __toModule(require("tiny-invariant"));
var ObserverArray = class {
  constructor() {
    this.observers = {};
    this.counter = 0;
    this.isEmpty = /* @__PURE__ */ __name(() => Object.values(this.observers).length === 0, "isEmpty");
  }
  call(message) {
    Object.values(this.observers).forEach((observer) => observer(message));
  }
  add(observer) {
    const key = this.counter++;
    this.observers[key] = observer;
    return key;
  }
  remove(key) {
    (0, import_tiny_invariant.default)(Object.prototype.hasOwnProperty.call(this.observers, key), `Could not remove observer: observer with key ${key} not exists`);
    delete this.observers[key];
  }
};
__name(ObserverArray, "ObserverArray");

// src/utils/pathUtils.ts
var import_toPath = __toModule(require("lodash/toPath"));
var import_pxth2 = __toModule(require("pxth"));
var import_tiny_invariant2 = __toModule(require("tiny-invariant"));
var joinPaths = /* @__PURE__ */ __name((...segments) => {
  const filteredSegments = segments.filter((segment) => segment !== import_pxth2.RootPathToken);
  if (filteredSegments.length === 0) {
    return import_pxth2.RootPathToken;
  }
  return filteredSegments.join(".");
}, "joinPaths");
function normalizePath(path) {
  return path === import_pxth2.RootPathToken ? path : (0, import_toPath.default)(path).join(".").trim();
}
__name(normalizePath, "normalizePath");
var isInnerPath = /* @__PURE__ */ __name((_basePath, _path) => {
  if (_basePath === import_pxth2.RootPathToken)
    return true;
  if (_path === import_pxth2.RootPathToken)
    return false;
  const path = normalizePath(_path);
  const basePath = normalizePath(_basePath);
  return path.indexOf(basePath + ".") === 0 && path.replace(basePath, "").trim().length > 0;
}, "isInnerPath");
var longestCommonPath = /* @__PURE__ */ __name((paths) => {
  if (paths.length === 0)
    return import_pxth2.RootPathToken;
  if (paths.length === 1)
    return normalizePath(paths[0]);
  const sortedPaths = paths.sort();
  const firstPath = (0, import_toPath.default)(sortedPaths[0]);
  const lastPath = (0, import_toPath.default)(sortedPaths[sortedPaths.length - 1]);
  for (let i = 0; i < firstPath.length; i++) {
    if (firstPath[i] !== lastPath[i]) {
      return firstPath.slice(0, i).join(".") || import_pxth2.RootPathToken;
    }
  }
  return firstPath.join(".");
}, "longestCommonPath");
var relativePath = /* @__PURE__ */ __name((_basePath, _subPath) => {
  const basePath = (0, import_pxth2.pxthToString)(_basePath);
  const subPath = (0, import_pxth2.pxthToString)(_subPath);
  if (basePath === import_pxth2.RootPathToken && subPath === import_pxth2.RootPathToken) {
    return (0, import_pxth2.createPxth)([]);
  }
  if (basePath === import_pxth2.RootPathToken) {
    return _subPath;
  }
  (0, import_tiny_invariant2.default)(subPath !== import_pxth2.RootPathToken, `ROOT_PATH symbol cannot be sub path of any path ("${basePath}")`);
  (0, import_tiny_invariant2.default)(basePath.length > 0 && subPath.indexOf(basePath) === 0, `"${subPath}" is not sub path of "${basePath}"`);
  if (basePath === subPath) {
    return (0, import_pxth2.createPxth)([]);
  } else {
    return (0, import_pxth2.createPxth)((0, import_pxth2.parseSegmentsFromString)(subPath.replace(basePath + ".", "")));
  }
}, "relativePath");

// src/utils/useLazyRef.ts
var import_react2 = __toModule(require("react"));
var useLazyRef = /* @__PURE__ */ __name((initializer) => {
  const ref = (0, import_react2.useRef)(null);
  if (ref.current === null) {
    ref.current = initializer();
  }
  return ref;
}, "useLazyRef");

// src/hooks/useObservers.ts
var useObservers = /* @__PURE__ */ __name(() => {
  const observers = (0, import_react3.useRef)({});
  const batchUpdateObservers = useLazyRef(() => new ObserverArray());
  const getObserversKeys = (0, import_react3.useCallback)(() => [
    ...Object.keys(observers.current),
    ...Object.getOwnPropertySymbols(observers.current)
  ], []);
  const batchUpdate = (0, import_react3.useCallback)((update) => {
    batchUpdateObservers.current.call(update);
  }, [batchUpdateObservers]);
  const observeBatchUpdates = (0, import_react3.useCallback)((observer) => batchUpdateObservers.current.add(observer), [batchUpdateObservers]);
  const stopObservingBatchUpdates = (0, import_react3.useCallback)((key) => batchUpdateObservers.current.remove(key), [
    batchUpdateObservers
  ]);
  const observe = (0, import_react3.useCallback)((path, observer) => {
    const pathKey = (0, import_pxth3.pxthToString)(path);
    if (!Object.prototype.hasOwnProperty.call(observers.current, pathKey)) {
      observers.current[pathKey] = new ObserverArray();
    }
    return observers.current[pathKey].add(observer);
  }, []);
  const stopObserving = (0, import_react3.useCallback)((path, observerKey) => {
    const pathKey = (0, import_pxth3.pxthToString)(path);
    const currentObservers = observers.current[pathKey];
    (0, import_tiny_invariant3.default)(currentObservers, "Cannot remove observer from value, which is not observing");
    currentObservers.remove(observerKey);
    if (currentObservers.isEmpty())
      delete observers.current[pathKey];
  }, []);
  const watch = (0, import_react3.useCallback)((path, observer) => {
    const key = observe(path, observer);
    return () => stopObserving(path, key);
  }, [observe, stopObserving]);
  const watchAll = (0, import_react3.useCallback)((observer) => watch((0, import_pxth3.createPxth)([]), observer), [watch]);
  const watchBatchUpdates = (0, import_react3.useCallback)((observer) => {
    const key = observeBatchUpdates(observer);
    return () => stopObservingBatchUpdates(key);
  }, [observeBatchUpdates, stopObservingBatchUpdates]);
  const isObserved = (0, import_react3.useCallback)((path) => Object.prototype.hasOwnProperty.call(observers.current, (0, import_pxth3.pxthToString)(path)), []);
  const notifyPaths = (0, import_react3.useCallback)((origin, paths, values) => {
    batchUpdate({ paths, origin, values });
    paths.forEach((path) => {
      const observer = observers.current[path];
      const subValue = (0, import_pxth3.deepGet)(values, (0, import_pxth3.createPxth)((0, import_pxth3.parseSegmentsFromString)(path)));
      observer.call(subValue);
    });
  }, [batchUpdate]);
  const notifySubTree = (0, import_react3.useCallback)((path, values) => {
    const stringifiedPath = (0, import_pxth3.pxthToString)(path);
    const subPaths = getObserversKeys().filter((tempPath) => isInnerPath(stringifiedPath, tempPath) || stringifiedPath === tempPath || isInnerPath(tempPath, stringifiedPath));
    notifyPaths(path, subPaths, values);
  }, [notifyPaths, getObserversKeys]);
  const notifyAll = (0, import_react3.useCallback)((values) => notifyPaths((0, import_pxth3.createPxth)([]), getObserversKeys(), values), [
    notifyPaths,
    getObserversKeys
  ]);
  return {
    watch,
    watchAll,
    watchBatchUpdates,
    isObserved,
    notifySubTree,
    notifyAll
  };
}, "useObservers");

// src/hooks/useStock.ts
var useStock = /* @__PURE__ */ __name(({ initialValues, debugName }) => {
  const values = useLazyRef(() => (0, import_cloneDeep.default)(initialValues));
  const { notifySubTree, notifyAll, watch, watchAll, watchBatchUpdates, isObserved } = useObservers();
  const setValue = (0, import_react4.useCallback)((path, action) => {
    const value = (0, import_isFunction.default)(action) ? action((0, import_pxth4.deepGet)(values.current, path)) : action;
    values.current = (0, import_pxth4.deepSet)(values.current, path, value);
    notifySubTree(path, values.current);
  }, [values, notifySubTree]);
  const setValues = (0, import_react4.useCallback)((newValues) => {
    values.current = newValues;
    notifyAll(newValues);
  }, [values, notifyAll]);
  const getValue = (0, import_react4.useCallback)((path) => (0, import_pxth4.deepGet)(values.current, path), [values]);
  const getValues = (0, import_react4.useCallback)(() => values.current, [values]);
  const resetValues = (0, import_react4.useCallback)(() => setValues((0, import_cloneDeep.default)(initialValues)), [initialValues, setValues]);
  const stock = (0, import_react4.useMemo)(() => ({
    getValue,
    getValues,
    setValue,
    setValues,
    resetValues,
    watch,
    watchAll,
    watchBatchUpdates,
    isObserved,
    debugName,
    paths: (0, import_pxth4.createPxth)([])
  }), [
    getValue,
    getValues,
    debugName,
    setValue,
    setValues,
    resetValues,
    watch,
    watchAll,
    watchBatchUpdates,
    isObserved
  ]);
  useDebugStock(stock);
  return stock;
}, "useStock");

// src/hooks/useStockContext.ts
var import_react10 = __toModule(require("react"));
var import_tiny_invariant5 = __toModule(require("tiny-invariant"));

// src/components/StockContext.ts
var import_react5 = __toModule(require("react"));
var StockContext = (0, import_react5.createContext)(void 0);

// src/components/StockRoot.tsx
var import_react6 = __toModule(require("react"));
var StockRoot = /* @__PURE__ */ __name((_a) => {
  var _b = _a, { children } = _b, stockConfig = __objRest(_b, ["children"]);
  const stock = useStock(stockConfig);
  return /* @__PURE__ */ import_react6.default.createElement(StockContext.Provider, {
    value: stock
  }, children);
}, "StockRoot");

// src/components/ProxyContext.ts
var import_react7 = __toModule(require("react"));
var ProxyContext = (0, import_react7.createContext)(void 0);

// src/components/ProxyProvider.tsx
var import_react8 = __toModule(require("react"));
var ProxyProvider = /* @__PURE__ */ __name(({ proxy, children }) => {
  const stock = useStockContext();
  return /* @__PURE__ */ import_react8.default.createElement(StockContext.Provider, {
    value: stock
  }, /* @__PURE__ */ import_react8.default.createElement(ProxyContext.Provider, {
    value: proxy
  }, typeof children === "function" ? children(proxy.path) : children));
}, "ProxyProvider");

// src/utils/useInterceptors.ts
var import_react9 = __toModule(require("react"));
var import_cloneDeep2 = __toModule(require("lodash/cloneDeep"));
var import_unset = __toModule(require("lodash/unset"));
var import_pxth5 = __toModule(require("pxth"));
var import_tiny_invariant4 = __toModule(require("tiny-invariant"));
var shouldUseProxy = /* @__PURE__ */ __name((proxy, path) => proxy && (isInnerPath((0, import_pxth5.pxthToString)(proxy.path), (0, import_pxth5.pxthToString)(path)) || (0, import_pxth5.pxthToString)(proxy.path) === (0, import_pxth5.pxthToString)(path)), "shouldUseProxy");
var intercept = /* @__PURE__ */ __name((proxy, path, standardCallback, proxiedCallback, args) => {
  if (!shouldUseProxy(proxy, path)) {
    return standardCallback(...args);
  } else {
    return proxiedCallback(...args);
  }
}, "intercept");
var useInterceptors = /* @__PURE__ */ __name((stock, proxy) => {
  const { watch, setValue, getValue, setValues, getValues } = stock;
  (0, import_react9.useEffect)(() => (0, import_tiny_invariant4.default)(!proxy || proxy.isActive(), "Cannot use not activated proxy. Maybe you forgot to call proxy.activate()?"), [proxy]);
  const interceptedWatch = (0, import_react9.useCallback)((path, observer) => intercept(proxy, path, watch, (path2, observer2) => proxy.watch(path2, observer2, watch), [path, observer]), [watch, proxy]);
  const interceptedSetValue = (0, import_react9.useCallback)((path, value) => intercept(proxy, path, setValue, (path2, value2) => proxy.setValue(path2, value2, setValue), [path, value]), [proxy, setValue]);
  const interceptedGetValue = (0, import_react9.useCallback)((path) => intercept(proxy, path, getValue, (path2) => proxy.getValue(path2, getValue), [
    path
  ]), [proxy, getValue]);
  const interceptedGetValues = (0, import_react9.useCallback)(() => {
    let allValues = (0, import_cloneDeep2.default)(getValues());
    const proxiedValue = proxy.getValue(proxy.path, getValue);
    allValues = (0, import_pxth5.deepSet)(allValues, proxy.path, proxiedValue);
    return allValues;
  }, [proxy, getValues, getValue]);
  const interceptedSetValues = (0, import_react9.useCallback)((values) => {
    const proxiedValue = (0, import_pxth5.deepGet)(values, proxy.path);
    (0, import_unset.default)(values, (0, import_pxth5.getPxthSegments)(proxy.path));
    proxy.setValue(proxy.path, proxiedValue, (path, value) => {
      (0, import_pxth5.deepSet)(values, path, value);
    });
    setValues(values);
  }, [proxy, setValues]);
  if (!proxy) {
    return stock;
  }
  return __spreadProps(__spreadValues({}, stock), {
    watch: interceptedWatch,
    setValue: interceptedSetValue,
    getValue: interceptedGetValue,
    getValues: interceptedGetValues,
    setValues: interceptedSetValues
  });
}, "useInterceptors");

// src/hooks/useStockContext.ts
var useStockContext = /* @__PURE__ */ __name((stock, proxy) => {
  const contextStock = (0, import_react10.useContext)(StockContext);
  const contextProxy = (0, import_react10.useContext)(ProxyContext);
  stock = stock != null ? stock : contextStock;
  proxy = proxy != null ? proxy : contextProxy;
  (0, import_tiny_invariant5.default)(stock, "You're trying to access stock outside StockContext and without providing custom stock.");
  return useInterceptors(stock, proxy);
}, "useStockContext");

// src/hooks/useStockValue.ts
var import_react11 = __toModule(require("react"));
var useStockValue = /* @__PURE__ */ __name((path, customStock, proxy) => {
  const stock = useStockContext(customStock, proxy);
  const { watch, getValue } = stock;
  const [, forceUpdate] = (0, import_react11.useReducer)((val) => val + 1, 0);
  const value = useLazyRef(() => getValue(path));
  (0, import_react11.useEffect)(() => watch(path, (newValue) => {
    value.current = newValue;
    forceUpdate();
  }), [path, watch, value]);
  return value.current;
}, "useStockValue");

// src/hooks/useStockState.ts
var import_react12 = __toModule(require("react"));
var useStockState = /* @__PURE__ */ __name((path, customStock, proxy) => {
  const stock = useStockContext(customStock, proxy);
  const value = useStockValue(path, customStock, proxy);
  const { setValue } = stock;
  const set = (0, import_react12.useCallback)((action) => setValue(path, action), [path, setValue]);
  return [value, set];
}, "useStockState");

// src/hooks/useAllStockValues.ts
var import_pxth6 = __toModule(require("pxth"));
var rootPxth = (0, import_pxth6.createPxth)([]);
var useAllStockValues = /* @__PURE__ */ __name((customStock, proxy) => {
  return useStockValue(rootPxth, customStock, proxy);
}, "useAllStockValues");

// src/hooks/useMappingProxy.ts
var import_react13 = __toModule(require("react"));
var import_pxth9 = __toModule(require("pxth"));

// src/typings/MappingProxy.ts
var import_isNil = __toModule(require("lodash/isNil"));
var import_pxth7 = __toModule(require("pxth"));
var import_tiny_invariant6 = __toModule(require("tiny-invariant"));

// src/typings/StockProxy.ts
var StockProxy = class {
  constructor(path) {
    this.activate = /* @__PURE__ */ __name(() => Object.freeze(this), "activate");
    this.isActive = /* @__PURE__ */ __name(() => Object.isFrozen(this), "isActive");
    this.path = path;
  }
};
__name(StockProxy, "StockProxy");

// src/typings/MappingProxy.ts
var MappingProxy = class extends StockProxy {
  constructor(map, path) {
    super(path);
    this.setValue = /* @__PURE__ */ __name((path, value, defaultSetValue) => {
      path = relativePath(this.path, path);
      const stringifiedPath = (0, import_pxth7.pxthToString)(path);
      const innerPaths = Object.entries(this.map).filter(([to]) => isInnerPath(stringifiedPath, to) || stringifiedPath === to);
      innerPaths.sort((a, b) => a.length - b.length).forEach(([to, from]) => from !== void 0 && defaultSetValue(from, (0, import_pxth7.deepGet)(value, relativePath(path, (0, import_pxth7.createPxth)((0, import_pxth7.parseSegmentsFromString)(to))))));
    }, "setValue");
    this.watch = /* @__PURE__ */ __name((path, observer, defaultWatch) => {
      const proxiedPath = this.getNormalPath(path);
      return defaultWatch(proxiedPath, (value) => observer(this.mapValue(value, path, proxiedPath)));
    }, "watch");
    this.getValue = /* @__PURE__ */ __name((path, defaultGetValue) => {
      const proxiedPath = this.getNormalPath(path);
      return this.mapValue(defaultGetValue(proxiedPath), path, proxiedPath);
    }, "getValue");
    this.mapValue = /* @__PURE__ */ __name((value, path, proxiedPath) => {
      path = relativePath(this.path, path);
      const stringifiedPath = (0, import_pxth7.pxthToString)(path);
      const innerPaths = Object.entries(this.map).filter(([to]) => isInnerPath(stringifiedPath, to) || stringifiedPath === to);
      return innerPaths.reduce((acc, [to, from]) => (0, import_pxth7.deepSet)(acc, relativePath(path, (0, import_pxth7.createPxth)((0, import_pxth7.parseSegmentsFromString)(to))), (0, import_pxth7.deepGet)(value, relativePath(proxiedPath, from))), {});
    }, "mapValue");
    this.getProxiedPath = /* @__PURE__ */ __name((path) => {
      var _a;
      const proxiedPath = (0, import_pxth7.pxthToString)(path);
      const normalPath = (_a = Object.entries(this.map).find(([, from]) => (0, import_pxth7.pxthToString)(from) === proxiedPath)) == null ? void 0 : _a[0];
      (0, import_tiny_invariant6.default)(!(0, import_isNil.default)(normalPath), "Mapping proxy error: trying to get normal path of proxied path, which is not defined in proxy map");
      return (0, import_pxth7.createPxth)((0, import_pxth7.parseSegmentsFromString)(joinPaths((0, import_pxth7.pxthToString)(this.path), normalPath)));
    }, "getProxiedPath");
    this.getNormalPath = /* @__PURE__ */ __name((path) => {
      const normalPath = relativePath(this.path, path);
      const stringifiedPath = (0, import_pxth7.pxthToString)(normalPath);
      const isIndependent = (0, import_pxth7.pxthToString)(normalPath) in this.map;
      (0, import_tiny_invariant6.default)(isIndependent || Object.keys(this.map).findIndex((proxiedPath) => isInnerPath(stringifiedPath, proxiedPath)) !== -1, "Mapping proxy error: trying to proxy value, which is not defined in proxy map.");
      return (0, import_pxth7.createPxth)((0, import_pxth7.parseSegmentsFromString)(isIndependent ? (0, import_pxth7.pxthToString)(this.map[stringifiedPath]) : longestCommonPath(Object.entries(this.map).filter(([to]) => isInnerPath(stringifiedPath, to)).map(([, from]) => (0, import_pxth7.pxthToString)(from)))));
    }, "getNormalPath");
    this.map = map;
  }
};
__name(MappingProxy, "MappingProxy");

// src/utils/areProxyMapsEqual.ts
var import_pxth8 = __toModule(require("pxth"));
var areProxyMapsEqual = /* @__PURE__ */ __name((a, b) => {
  const aEntries = Object.entries(a);
  if (aEntries.length !== Object.entries(b).length) {
    return false;
  }
  for (const [key, value] of aEntries) {
    if (typeof b[key] !== "object" || b[key] === null || (0, import_pxth8.pxthToString)(b[key]) !== (0, import_pxth8.pxthToString)(value)) {
      return false;
    }
  }
  return true;
}, "areProxyMapsEqual");

// src/hooks/useMappingProxy.ts
var useMapMemo = /* @__PURE__ */ __name((map) => {
  const mapRef = (0, import_react13.useRef)(map);
  (0, import_react13.useEffect)(() => {
    if (!areProxyMapsEqual(mapRef.current, map)) {
      mapRef.current = map;
    }
  }, [map]);
  return areProxyMapsEqual(mapRef.current, map) ? mapRef.current : map;
}, "useMapMemo");
var useMappingProxy = /* @__PURE__ */ __name((map, path) => {
  const realMap = useMapMemo(map);
  return (0, import_react13.useMemo)(() => {
    const proxy = new MappingProxy(realMap, path);
    proxy.activate();
    return proxy;
  }, [(0, import_pxth9.pxthToString)(path), realMap]);
}, "useMappingProxy");
