var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};

// src/hooks/useStock.ts
import { useCallback as useCallback2, useMemo } from "react";
import cloneDeep from "lodash/cloneDeep";
import isFunction from "lodash/isFunction";
import { createPxth as createPxth3, deepGet as deepGet2, deepSet } from "pxth";

// src/hooks/useDebugStock.ts
import { useEffect } from "react";
import { getPxthSegments } from "pxth";
var StockedEvent;
(function(StockedEvent2) {
  StockedEvent2["NEW"] = "new";
  StockedEvent2["BATCH_UPDATE"] = "update";
})(StockedEvent || (StockedEvent = {}));
var stockIndex = -1;
var useDebugStock = /* @__PURE__ */ __name((stock) => {
  useEffect(() => {
    if (window.__STOCKED_DEVTOOLS_HOOK) {
      const currentStockId = ++stockIndex;
      window.__STOCKED_DEVTOOLS_HOOK.raiseEvent(StockedEvent.NEW, {
        data: stock.getValues(),
        id: currentStockId
      });
      return stock.watchBatchUpdates((data) => window.__STOCKED_DEVTOOLS_HOOK.raiseEvent(StockedEvent.BATCH_UPDATE, {
        data: __spreadProps(__spreadValues({}, data), {
          origin: getPxthSegments(data.origin)
        }),
        id: currentStockId
      }));
    }
    return () => {
    };
  }, []);
}, "useDebugStock");

// src/hooks/useObservers.ts
import { useCallback, useRef as useRef2 } from "react";
import { createPxth as createPxth2, deepGet, parseSegmentsFromString as parseSegmentsFromString2, pxthToString as pxthToString2 } from "pxth";
import invariant3 from "tiny-invariant";

// src/utils/ObserverArray.ts
import invariant from "tiny-invariant";
var ObserverArray = class {
  constructor() {
    this.observers = {};
    this.counter = 0;
    this.isEmpty = /* @__PURE__ */ __name(() => Object.values(this.observers).length === 0, "isEmpty");
  }
  call(message) {
    Object.values(this.observers).forEach((observer) => observer(message));
  }
  add(observer) {
    const key = this.counter++;
    this.observers[key] = observer;
    return key;
  }
  remove(key) {
    invariant(Object.prototype.hasOwnProperty.call(this.observers, key), `Could not remove observer: observer with key ${key} not exists`);
    delete this.observers[key];
  }
};
__name(ObserverArray, "ObserverArray");

// src/utils/pathUtils.ts
import toPath from "lodash/toPath";
import { createPxth, parseSegmentsFromString, pxthToString, RootPathToken } from "pxth";
import invariant2 from "tiny-invariant";
var joinPaths = /* @__PURE__ */ __name((...segments) => {
  const filteredSegments = segments.filter((segment) => segment !== RootPathToken);
  if (filteredSegments.length === 0) {
    return RootPathToken;
  }
  return filteredSegments.join(".");
}, "joinPaths");
function normalizePath(path) {
  return path === RootPathToken ? path : toPath(path).join(".").trim();
}
__name(normalizePath, "normalizePath");
var isInnerPath = /* @__PURE__ */ __name((_basePath, _path) => {
  if (_basePath === RootPathToken)
    return true;
  if (_path === RootPathToken)
    return false;
  const path = normalizePath(_path);
  const basePath = normalizePath(_basePath);
  return path.indexOf(basePath + ".") === 0 && path.replace(basePath, "").trim().length > 0;
}, "isInnerPath");
var longestCommonPath = /* @__PURE__ */ __name((paths) => {
  if (paths.length === 0)
    return RootPathToken;
  if (paths.length === 1)
    return normalizePath(paths[0]);
  const sortedPaths = paths.sort();
  const firstPath = toPath(sortedPaths[0]);
  const lastPath = toPath(sortedPaths[sortedPaths.length - 1]);
  for (let i = 0; i < firstPath.length; i++) {
    if (firstPath[i] !== lastPath[i]) {
      return firstPath.slice(0, i).join(".") || RootPathToken;
    }
  }
  return firstPath.join(".");
}, "longestCommonPath");
var relativePath = /* @__PURE__ */ __name((_basePath, _subPath) => {
  const basePath = pxthToString(_basePath);
  const subPath = pxthToString(_subPath);
  if (basePath === RootPathToken && subPath === RootPathToken) {
    return createPxth([]);
  }
  if (basePath === RootPathToken) {
    return _subPath;
  }
  invariant2(subPath !== RootPathToken, `ROOT_PATH symbol cannot be sub path of any path ("${basePath}")`);
  invariant2(basePath.length > 0 && subPath.indexOf(basePath) === 0, `"${subPath}" is not sub path of "${basePath}"`);
  if (basePath === subPath) {
    return createPxth([]);
  } else {
    return createPxth(parseSegmentsFromString(subPath.replace(basePath + ".", "")));
  }
}, "relativePath");

// src/utils/useLazyRef.ts
import { useRef } from "react";
var useLazyRef = /* @__PURE__ */ __name((initializer) => {
  const ref = useRef(null);
  if (ref.current === null) {
    ref.current = initializer();
  }
  return ref;
}, "useLazyRef");

// src/hooks/useObservers.ts
var useObservers = /* @__PURE__ */ __name(() => {
  const observers = useRef2({});
  const batchUpdateObservers = useLazyRef(() => new ObserverArray());
  const getObserversKeys = useCallback(() => [
    ...Object.keys(observers.current),
    ...Object.getOwnPropertySymbols(observers.current)
  ], []);
  const batchUpdate = useCallback((update) => {
    batchUpdateObservers.current.call(update);
  }, [batchUpdateObservers]);
  const observeBatchUpdates = useCallback((observer) => batchUpdateObservers.current.add(observer), [batchUpdateObservers]);
  const stopObservingBatchUpdates = useCallback((key) => batchUpdateObservers.current.remove(key), [
    batchUpdateObservers
  ]);
  const observe = useCallback((path, observer) => {
    const pathKey = pxthToString2(path);
    if (!Object.prototype.hasOwnProperty.call(observers.current, pathKey)) {
      observers.current[pathKey] = new ObserverArray();
    }
    return observers.current[pathKey].add(observer);
  }, []);
  const stopObserving = useCallback((path, observerKey) => {
    const pathKey = pxthToString2(path);
    const currentObservers = observers.current[pathKey];
    invariant3(currentObservers, "Cannot remove observer from value, which is not observing");
    currentObservers.remove(observerKey);
    if (currentObservers.isEmpty())
      delete observers.current[pathKey];
  }, []);
  const watch = useCallback((path, observer) => {
    const key = observe(path, observer);
    return () => stopObserving(path, key);
  }, [observe, stopObserving]);
  const watchAll = useCallback((observer) => watch(createPxth2([]), observer), [watch]);
  const watchBatchUpdates = useCallback((observer) => {
    const key = observeBatchUpdates(observer);
    return () => stopObservingBatchUpdates(key);
  }, [observeBatchUpdates, stopObservingBatchUpdates]);
  const isObserved = useCallback((path) => Object.prototype.hasOwnProperty.call(observers.current, pxthToString2(path)), []);
  const notifyPaths = useCallback((origin, paths, values) => {
    batchUpdate({ paths, origin, values });
    paths.forEach((path) => {
      const observer = observers.current[path];
      const subValue = deepGet(values, createPxth2(parseSegmentsFromString2(path)));
      observer.call(subValue);
    });
  }, [batchUpdate]);
  const notifySubTree = useCallback((path, values) => {
    const stringifiedPath = pxthToString2(path);
    const subPaths = getObserversKeys().filter((tempPath) => isInnerPath(stringifiedPath, tempPath) || stringifiedPath === tempPath || isInnerPath(tempPath, stringifiedPath));
    notifyPaths(path, subPaths, values);
  }, [notifyPaths, getObserversKeys]);
  const notifyAll = useCallback((values) => notifyPaths(createPxth2([]), getObserversKeys(), values), [
    notifyPaths,
    getObserversKeys
  ]);
  return {
    watch,
    watchAll,
    watchBatchUpdates,
    isObserved,
    notifySubTree,
    notifyAll
  };
}, "useObservers");

// src/hooks/useStock.ts
var useStock = /* @__PURE__ */ __name(({ initialValues, debugName }) => {
  const values = useLazyRef(() => cloneDeep(initialValues));
  const { notifySubTree, notifyAll, watch, watchAll, watchBatchUpdates, isObserved } = useObservers();
  const setValue = useCallback2((path, action) => {
    const value = isFunction(action) ? action(deepGet2(values.current, path)) : action;
    values.current = deepSet(values.current, path, value);
    notifySubTree(path, values.current);
  }, [values, notifySubTree]);
  const setValues = useCallback2((newValues) => {
    values.current = newValues;
    notifyAll(newValues);
  }, [values, notifyAll]);
  const getValue = useCallback2((path) => deepGet2(values.current, path), [values]);
  const getValues = useCallback2(() => values.current, [values]);
  const resetValues = useCallback2(() => setValues(cloneDeep(initialValues)), [initialValues, setValues]);
  const stock = useMemo(() => ({
    getValue,
    getValues,
    setValue,
    setValues,
    resetValues,
    watch,
    watchAll,
    watchBatchUpdates,
    isObserved,
    debugName,
    paths: createPxth3([])
  }), [
    getValue,
    getValues,
    debugName,
    setValue,
    setValues,
    resetValues,
    watch,
    watchAll,
    watchBatchUpdates,
    isObserved
  ]);
  useDebugStock(stock);
  return stock;
}, "useStock");

// src/hooks/useStockContext.ts
import { useContext } from "react";
import invariant5 from "tiny-invariant";

// src/components/StockContext.ts
import { createContext } from "react";
var StockContext = createContext(void 0);

// src/components/StockRoot.tsx
import React from "react";
var StockRoot = /* @__PURE__ */ __name((_a) => {
  var _b = _a, { children } = _b, stockConfig = __objRest(_b, ["children"]);
  const stock = useStock(stockConfig);
  return /* @__PURE__ */ React.createElement(StockContext.Provider, {
    value: stock
  }, children);
}, "StockRoot");

// src/components/ProxyContext.ts
import { createContext as createContext2 } from "react";
var ProxyContext = createContext2(void 0);

// src/components/ProxyProvider.tsx
import React2 from "react";
var ProxyProvider = /* @__PURE__ */ __name(({ proxy, children }) => {
  const stock = useStockContext();
  return /* @__PURE__ */ React2.createElement(StockContext.Provider, {
    value: stock
  }, /* @__PURE__ */ React2.createElement(ProxyContext.Provider, {
    value: proxy
  }, typeof children === "function" ? children(proxy.path) : children));
}, "ProxyProvider");

// src/utils/useInterceptors.ts
import { useCallback as useCallback3, useEffect as useEffect2 } from "react";
import cloneDeep2 from "lodash/cloneDeep";
import unset from "lodash/unset";
import { deepGet as deepGet3, deepSet as deepSet2, getPxthSegments as getPxthSegments2, pxthToString as pxthToString3 } from "pxth";
import invariant4 from "tiny-invariant";
var shouldUseProxy = /* @__PURE__ */ __name((proxy, path) => proxy && (isInnerPath(pxthToString3(proxy.path), pxthToString3(path)) || pxthToString3(proxy.path) === pxthToString3(path)), "shouldUseProxy");
var intercept = /* @__PURE__ */ __name((proxy, path, standardCallback, proxiedCallback, args) => {
  if (!shouldUseProxy(proxy, path)) {
    return standardCallback(...args);
  } else {
    return proxiedCallback(...args);
  }
}, "intercept");
var useInterceptors = /* @__PURE__ */ __name((stock, proxy) => {
  const { watch, setValue, getValue, setValues, getValues } = stock;
  useEffect2(() => invariant4(!proxy || proxy.isActive(), "Cannot use not activated proxy. Maybe you forgot to call proxy.activate()?"), [proxy]);
  const interceptedWatch = useCallback3((path, observer) => intercept(proxy, path, watch, (path2, observer2) => proxy.watch(path2, observer2, watch), [path, observer]), [watch, proxy]);
  const interceptedSetValue = useCallback3((path, value) => intercept(proxy, path, setValue, (path2, value2) => proxy.setValue(path2, value2, setValue), [path, value]), [proxy, setValue]);
  const interceptedGetValue = useCallback3((path) => intercept(proxy, path, getValue, (path2) => proxy.getValue(path2, getValue), [
    path
  ]), [proxy, getValue]);
  const interceptedGetValues = useCallback3(() => {
    let allValues = cloneDeep2(getValues());
    const proxiedValue = proxy.getValue(proxy.path, getValue);
    allValues = deepSet2(allValues, proxy.path, proxiedValue);
    return allValues;
  }, [proxy, getValues, getValue]);
  const interceptedSetValues = useCallback3((values) => {
    const proxiedValue = deepGet3(values, proxy.path);
    unset(values, getPxthSegments2(proxy.path));
    proxy.setValue(proxy.path, proxiedValue, (path, value) => {
      deepSet2(values, path, value);
    });
    setValues(values);
  }, [proxy, setValues]);
  if (!proxy) {
    return stock;
  }
  return __spreadProps(__spreadValues({}, stock), {
    watch: interceptedWatch,
    setValue: interceptedSetValue,
    getValue: interceptedGetValue,
    getValues: interceptedGetValues,
    setValues: interceptedSetValues
  });
}, "useInterceptors");

// src/hooks/useStockContext.ts
var useStockContext = /* @__PURE__ */ __name((stock, proxy) => {
  const contextStock = useContext(StockContext);
  const contextProxy = useContext(ProxyContext);
  stock = stock != null ? stock : contextStock;
  proxy = proxy != null ? proxy : contextProxy;
  invariant5(stock, "You're trying to access stock outside StockContext and without providing custom stock.");
  return useInterceptors(stock, proxy);
}, "useStockContext");

// src/hooks/useStockValue.ts
import { useEffect as useEffect3, useReducer } from "react";
var useStockValue = /* @__PURE__ */ __name((path, customStock, proxy) => {
  const stock = useStockContext(customStock, proxy);
  const { watch, getValue } = stock;
  const [, forceUpdate] = useReducer((val) => val + 1, 0);
  const value = useLazyRef(() => getValue(path));
  useEffect3(() => watch(path, (newValue) => {
    value.current = newValue;
    forceUpdate();
  }), [path, watch, value]);
  return value.current;
}, "useStockValue");

// src/hooks/useStockState.ts
import { useCallback as useCallback4 } from "react";
var useStockState = /* @__PURE__ */ __name((path, customStock, proxy) => {
  const stock = useStockContext(customStock, proxy);
  const value = useStockValue(path, customStock, proxy);
  const { setValue } = stock;
  const set = useCallback4((action) => setValue(path, action), [path, setValue]);
  return [value, set];
}, "useStockState");

// src/hooks/useAllStockValues.ts
import { createPxth as createPxth4 } from "pxth";
var rootPxth = createPxth4([]);
var useAllStockValues = /* @__PURE__ */ __name((customStock, proxy) => {
  return useStockValue(rootPxth, customStock, proxy);
}, "useAllStockValues");

// src/hooks/useMappingProxy.ts
import { useEffect as useEffect4, useMemo as useMemo2, useRef as useRef3 } from "react";
import { pxthToString as pxthToString6 } from "pxth";

// src/typings/MappingProxy.ts
import isNil from "lodash/isNil";
import { createPxth as createPxth5, deepGet as deepGet4, deepSet as deepSet3, parseSegmentsFromString as parseSegmentsFromString3, pxthToString as pxthToString4 } from "pxth";
import invariant6 from "tiny-invariant";

// src/typings/StockProxy.ts
var StockProxy = class {
  constructor(path) {
    this.activate = /* @__PURE__ */ __name(() => Object.freeze(this), "activate");
    this.isActive = /* @__PURE__ */ __name(() => Object.isFrozen(this), "isActive");
    this.path = path;
  }
};
__name(StockProxy, "StockProxy");

// src/typings/MappingProxy.ts
var MappingProxy = class extends StockProxy {
  constructor(map, path) {
    super(path);
    this.setValue = /* @__PURE__ */ __name((path, value, defaultSetValue) => {
      path = relativePath(this.path, path);
      const stringifiedPath = pxthToString4(path);
      const innerPaths = Object.entries(this.map).filter(([to]) => isInnerPath(stringifiedPath, to) || stringifiedPath === to);
      innerPaths.sort((a, b) => a.length - b.length).forEach(([to, from]) => from !== void 0 && defaultSetValue(from, deepGet4(value, relativePath(path, createPxth5(parseSegmentsFromString3(to))))));
    }, "setValue");
    this.watch = /* @__PURE__ */ __name((path, observer, defaultWatch) => {
      const proxiedPath = this.getNormalPath(path);
      return defaultWatch(proxiedPath, (value) => observer(this.mapValue(value, path, proxiedPath)));
    }, "watch");
    this.getValue = /* @__PURE__ */ __name((path, defaultGetValue) => {
      const proxiedPath = this.getNormalPath(path);
      return this.mapValue(defaultGetValue(proxiedPath), path, proxiedPath);
    }, "getValue");
    this.mapValue = /* @__PURE__ */ __name((value, path, proxiedPath) => {
      path = relativePath(this.path, path);
      const stringifiedPath = pxthToString4(path);
      const innerPaths = Object.entries(this.map).filter(([to]) => isInnerPath(stringifiedPath, to) || stringifiedPath === to);
      return innerPaths.reduce((acc, [to, from]) => deepSet3(acc, relativePath(path, createPxth5(parseSegmentsFromString3(to))), deepGet4(value, relativePath(proxiedPath, from))), {});
    }, "mapValue");
    this.getProxiedPath = /* @__PURE__ */ __name((path) => {
      var _a;
      const proxiedPath = pxthToString4(path);
      const normalPath = (_a = Object.entries(this.map).find(([, from]) => pxthToString4(from) === proxiedPath)) == null ? void 0 : _a[0];
      invariant6(!isNil(normalPath), "Mapping proxy error: trying to get normal path of proxied path, which is not defined in proxy map");
      return createPxth5(parseSegmentsFromString3(joinPaths(pxthToString4(this.path), normalPath)));
    }, "getProxiedPath");
    this.getNormalPath = /* @__PURE__ */ __name((path) => {
      const normalPath = relativePath(this.path, path);
      const stringifiedPath = pxthToString4(normalPath);
      const isIndependent = pxthToString4(normalPath) in this.map;
      invariant6(isIndependent || Object.keys(this.map).findIndex((proxiedPath) => isInnerPath(stringifiedPath, proxiedPath)) !== -1, "Mapping proxy error: trying to proxy value, which is not defined in proxy map.");
      return createPxth5(parseSegmentsFromString3(isIndependent ? pxthToString4(this.map[stringifiedPath]) : longestCommonPath(Object.entries(this.map).filter(([to]) => isInnerPath(stringifiedPath, to)).map(([, from]) => pxthToString4(from)))));
    }, "getNormalPath");
    this.map = map;
  }
};
__name(MappingProxy, "MappingProxy");

// src/utils/areProxyMapsEqual.ts
import { pxthToString as pxthToString5 } from "pxth";
var areProxyMapsEqual = /* @__PURE__ */ __name((a, b) => {
  const aEntries = Object.entries(a);
  if (aEntries.length !== Object.entries(b).length) {
    return false;
  }
  for (const [key, value] of aEntries) {
    if (typeof b[key] !== "object" || b[key] === null || pxthToString5(b[key]) !== pxthToString5(value)) {
      return false;
    }
  }
  return true;
}, "areProxyMapsEqual");

// src/hooks/useMappingProxy.ts
var useMapMemo = /* @__PURE__ */ __name((map) => {
  const mapRef = useRef3(map);
  useEffect4(() => {
    if (!areProxyMapsEqual(mapRef.current, map)) {
      mapRef.current = map;
    }
  }, [map]);
  return areProxyMapsEqual(mapRef.current, map) ? mapRef.current : map;
}, "useMapMemo");
var useMappingProxy = /* @__PURE__ */ __name((map, path) => {
  const realMap = useMapMemo(map);
  return useMemo2(() => {
    const proxy = new MappingProxy(realMap, path);
    proxy.activate();
    return proxy;
  }, [pxthToString6(path), realMap]);
}, "useMappingProxy");
export {
  MappingProxy,
  ObserverArray,
  ProxyContext,
  ProxyProvider,
  StockContext,
  StockProxy,
  StockRoot,
  intercept,
  isInnerPath,
  joinPaths,
  longestCommonPath,
  normalizePath,
  relativePath,
  useAllStockValues,
  useMappingProxy,
  useObservers,
  useStock,
  useStockContext,
  useStockState,
  useStockValue
};
